Subject: bug#46316: 27.1; wrong horizontal scroll with truncate-lines value t

From: Eli Zaretskii <[email-masked]>
Date: Sat, 13 Feb 2021 17:30:38 +0200

> Cc: [email-masked]
> From: [email-masked]
> Date: Sat, 13 Feb 2021 00:41:18 +0900
> 
> #'isearch-update tries to control the hsrcoll using
> #'pos-visible-in-window-group-p.
> Under the folloing conditions, it returns coordinates as if the point is
> at the beginning of a virtual next line.
>   (1) the point is the end of the buffer.
>   (2) the buffer does not end with a newline.
>   (3) the last line is displayed in the window.
>   (4) the last line is truncated.
> So the calculation is wrong and the hscroll becomes inappropriate.

Thanks, I wasn't aware isearch called pos-visible-in-window-p.

I fixed pos-visible-in-window-p on the master branch in this case, so
this part of the report now works correctly.

> With a different reason, if isearch started with a large hscroll and the
> last match is near the beginning of a line, the hscroll becomes
> inapropriate.
> For example, evaluate the form below, and type 'C-s a C-s', then the
> current point is hidden to the left of the window.
> This is because #'isearch-update only checks whether the point is to the
> right of the window and does not check whether the point is to the left
> of the window.
> 
> (let ((buf (generate-new-buffer "tmp")))
>   (switch-to-buffer buf)
>   (setq truncate-lines t)
>   (insert-char ?x 100)
>   (save-excursion
>     (insert-char ?\n 100)
>     (insert ?a)))

This now also works correctly.

> Regarding image-mode, a simpler example of the bug is written as below.
> The hscroll does not change when the buffer is changed.
> Image display, window focus or message is not related.
> 
> (let ((buf (generate-new-buffer "tmp")))
>   (switch-to-buffer buf)
>   (setq truncate-lines t)
>   (dotimes (i 200)
>     (insert (format ":%03d" i))
>     (when (= 0 (% (1+ i) 100)) (insert ?\n)))
>   (forward-char -1)
>   (sit-for 1)
>   (set-window-hscroll nil (window-hscroll))
>   (save-excursion
>     (forward-char -100)
>     (insert-char ?\n 10)
>     ))

Sorry, I don't think I follow: what exactly is the bug here?  What did
you expect to happen ,and what did actually happen?